package net.brokenmoon.afloydwiremod.mixin;

import net.brokenmoon.afloydwiremod.mixinInterfaces.INetHandler;
import net.brokenmoon.afloydwiremod.packet.WiremodPacketSyncIO;
import net.brokenmoon.afloydwiremod.packet.WiremodProgrammerGuiPacket;
import net.brokenmoon.afloydwiremod.packet.WiremodProgrammerPacket;
import net.brokenmoon.afloydwiremod.packet.WiremodWiringGuiPacket;
import net.brokenmoon.afloydwiremod.tileentity.ChipTileEntity;
import net.minecraft.server.MinecraftServer;
import net.minecraft.src.EntityPlayerMP;
import net.minecraft.src.NetServerHandler;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;

@Mixin(value = NetServerHandler.class, remap = false)
public class MixinNetServerHandler implements INetHandler {
    @Shadow
    private MinecraftServer mcServer;
    @Shadow
    private EntityPlayerMP playerEntity;

    @Override
    public void wiremodHandleOpenProgrammerGUI(WiremodProgrammerGuiPacket packet) {

    }

    @Override
    public void wiremodHandleProgramTile(WiremodProgrammerPacket packet) {
        ((ChipTileEntity)this.mcServer.getWorldManager(this.playerEntity.dimension).getBlockTileEntity(packet.x, packet.y, packet.z)).setMode(packet.mode);
    }

    @Override
    public void wiremodHandleOpenWiringGUI(WiremodWiringGuiPacket wiremodWiringGuiPacket) {

    }

    @Override
    public void handleIODisc(WiremodPacketSyncIO wiremodPacketSyncIO) {

    }
}
